; 
; Stick control
; 
; 

	CPU	Z80
	ORG	0B000H
	
PORTC:	EQU	0E002H
PORTJ:	EQU	08H
;
; CALL JA1 = STICK1 X
; CALL JA2 = STICK1 Y
;
; CALL JB1 = STICK2 X
; CALL JB2 = STICK2 Y
;
; ANSWER = Acc A REGISTER
;
JA1:	LD	A,4EH		; BIT 1,(HL)
	JR	LP0
;
JA2:	LD	A,56H		; BIT 2,(HL)
	JR	LP0
;
JB1:	LD	A,5EH		; BIT 3,(HL)
	JR	LP0
;
JB2:	LD	A,66H		; BIT 4,(HL)
;
LP0:	DI
	PUSH HL
	PUSH	DE
	LD	(LP4+2),A	; OPERAND SET
	LD	DE,0FFFFH
	LD	HL,PORTC
LP1:	BIT	7,(HL)		; WAIT V-BLANK HIGH
	JP	Z,LP1
LP2:	BIT	7,(HL)		; WAIT V-BLANK LOW
	JP	NZ,LP2
	LD	L,PORTJ
	LD	A,11H
LP3:	DEC	A		; TIME DELAY
	JR	NZ,LP3
LP4:	INC	DE		; COUNTER ADD TO ONE
	BIT	0,(HL)		; LEVEL CHECK
	JP	Z,LP4		; NEXT COUNT
	LD	A,D		; OVER COUNT CHECK
	OR	A
	LD	A,E
	POP	DE
	POP	HL
	EI
	RET	Z
	LD	A,0FFH		; MAX COUNT SET
	RET
;
; CONTROL SWITCH
;
;
; CALL SW1 = STICK1 SWITCH1
; CALL SW2 = STICK1 SWITCH2
; CALL SW3 = STICK2 SWITCH1
; CALL SW4 = STICK2 SWITCH2
;
; ANSWER = Acc A REGISTER
;
SW1:	LD	A,4EH		; BIT 1,(HL)
	JR	LP5
;
SW2:	LD	A,56H		; BIT 2,(HL)
	JR	LP5
;
SW3:	LD	A,5EH		; BIT 3,(HL)
	JR	LP5
;
SW4:	LD	A,66H		; BIT 4,(HL)
;
LP5:	DI
	LD	(LPB+1),A	; OPERAND SET
	LD	(LP7+1),A	;
	PUSH	HL
	LD	HL,0E002H
LP6:	BIT	7,(HL)		; WAIT V-BLANK HIGH
	JP	Z,LP6
	LD	L,PORTJ
LP7:	BIT	0,(HL)		; SWITCH CHECK
	LD	A,L
	JP	Z,LP8		; PUSH SWITCH 1
	XOR	A
LP8:	LD	(LPD),A
	LD	A,9
LP9:	PUSH	AF		; WAIT 10.4 ms
	XOR	A
LP9A:	DEC	A
	JR	NZ,LP9A
	POP	AF
	DEC	A
	JR	NZ,LP9
	LD	L,2
LPA:	BIT	7,(HL)
	JP	Z,LPA
	LD	L,PORTJ
LPB:	BIT	0,(HL)		; SWITCH CHECK 2
	LD	A,L
	JP	Z,LPC		; PUSH SWITCH 2
	XOR	A
LPC:	LD	L,A
	DB	3EH
LPD:	DB	00H
	AND	L
	POP	HL
	EI
	RET	
